#include <gb.h>
unsigned char PrinterStatus[3];

unsigned char PRINTER_INIT[]={
10,0x88,0x33,0x01,0x00,0x00,0x00,0x01,0x00,0x00,0x00
};
unsigned char PRINTER_STATUS[]={
10,0x88,0x33,0x0F,0x00,0x00,0x00,0x0F,0x00,0x00,0x00
};
unsigned char PRINTER_EOF[]={
10,0x88,0x33,0x04,0x00,0x00,0x00,0x04,0x00,0x00,0x00
};
unsigned char PRINTER_START[]={
14,0x88,0x33,0x02,0x00,0x04,0x00,0x01,0x13,0xE4,0x40,0x3E,0x01,0x00,0x00
};
unsigned char PRINT_TILE[]={
6,0x88,0x33,0x04,0x00,0x80,0x02
};
unsigned char PRINTER_LINE[]={
14,0x88,0x33,0x02,0x00,0x04,0x00,0x01,0x00,0xE4,0x40,0x3E,0x01,0x00,0x00
};

UBYTE tile_num, packet_num;

unsigned long CRC;

void SendByte(unsigned char byte){
        unsigned char result;
        result = SendPrinterByte(byte);
        PrinterStatus[0]=PrinterStatus[1];
        PrinterStatus[1]=PrinterStatus[2];
        PrinterStatus[2]=result;
}

void SendPrinterCommand(unsigned char *Command){
        unsigned char length,index,key;
        index=0;
        length=*Command;
        while(index<length){
                index++;
                SendByte(*(Command+index));
        }
}

void PrinterInit (void)
{
  tile_num = 0;
  CRC = 0;
  packet_num = 0;

  SendPrinterCommand(PRINTER_INIT);
}

int CheckLinkCable(){
        if(PrinterStatus[0] != 0){
                return 2;
        }
        if((PrinterStatus[1] & 0xF0)!=0x80){
                return 2;
        }
        return 0;
}

int GetPrinterStatus(){
        SendPrinterCommand(PRINTER_STATUS);
        return CheckLinkCable();
}

int CheckForErrors(){
        if(PrinterStatus[2] & 128){
                return 1;
        }
        if(PrinterStatus[2] & 64){
                return 4;
        }
        if(PrinterStatus[2] & 32){
                return 3;
        }
        return 0;
}

void PrintTileData(unsigned char *TileData){
  unsigned char CRCLow,CRCHigh,TileIndex;
  
  if (tile_num == 0)
  {
    SendPrinterCommand(PRINT_TILE);
    CRC=0x04+0x80 + 0x02;
  }      
  
  tile_num ++;

  for(TileIndex=0;TileIndex<16;TileIndex++)
  {
    CRC+=TileData[TileIndex];
    SendByte(TileData[TileIndex]);
  }

  if (tile_num == 40)
  {
    CRCLow=GetLow(CRC);
    CRCHigh=GetHigh(CRC);
    SendByte(CRCLow);
    SendByte(CRCHigh);
    SendByte(0x00);
    SendByte(0x00);
    tile_num = 0;  
    CRC = 0;
    packet_num ++;

    if (packet_num == 9) // all done the page
    {
      SendPrinterCommand(PRINTER_EOF); // data end packet
      SendPrinterCommand(PRINTER_START);
      packet_num = 0;
    }
  }
}

