#include <gb.h>
#include "PrintCmd.h"
#include "font.c"
#include "pic_tiles.c"
#include "pic_map.c"

unsigned char p_data[16];

static const unsigned char cEMPTY[] = 
{ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0}; 
/* an empty line for the background */

void clear_screen (void)
{
  UBYTE e; 
  char *x ;
  
  HIDE_BKG;
  HIDE_SPRITES;

  for (e=0; e<40; e++)
    move_sprite(e,0,0);

  for (e=0; e<20; e++)
  {
    set_bkg_tiles (0,e,20,1,(unsigned char *) &cEMPTY[0]);   
    set_win_tiles (0,e,20,1,(unsigned char *) &cEMPTY[0]);   

    // set palette to 1
    x = (char *) 0xFF4F;
    x[0] = 1;
    set_bkg_tiles (0,e,20,1,(unsigned char *) &cEMPTY[0]);   
    x[0] = 0;

  }

  move_bkg (0,0);
  
  SHOW_BKG;
  SHOW_SPRITES;
}

void p_err (char *str,unsigned char r)
{
  UBYTE t;
  UBYTE e;

  for (e=0;e<20;e++)
  {
    t= str[e]+128;
    set_bkg_tiles (e,0,1,1,(unsigned char *)&t);
  }

  t=r+176;
  set_bkg_tiles (0,1,1,1,(unsigned char *)&t);
  while (1); // never leave the error message screen ! 

}

void p_tell (char *str,unsigned char r)
{
  UBYTE t;
  UBYTE e;

  for (e=0;e<20;e++)
  {
    t= str[e]+128;
    set_bkg_tiles (e,0,1,1,(unsigned char *)&t);
  }

  t=r+176;
  set_bkg_tiles (0,1,1,1,(unsigned char *)&t);
 
}

char text[40] = "This is a test of   the Gameboy Printer ";


void main(){
  unsigned char index,result;
  unsigned long y,x, bgtile;
  UBYTE e,f,px,py;
 
  set_bkg_data(128,128,&font[0]);
  set_bkg_data(0,158,&pic_tiles[0]);
  set_bkg_tiles(0,0,20,18,&pic_map[0]);

  SHOW_BKG;

  y = 0;

  PrinterInit();

  result = CheckLinkCable();
  if(result !=0){
    p_err("check link          ",result);
  }
  result=CheckForErrors();
  if(result !=0){
    p_err("check error         ",result);
  }

  for (py=0;py<18;py++)
  {
    p_tell("Sending Data line   ",py);
    for (px=0;px<20;px++)
    {
      x = (py+e+e);
      x = x * 20;
      x = x + px;
      bgtile = pic_map[x];
      x = bgtile*16; 
      for (f=0;f<16;f++)
      {
        p_data[f] = pic_tiles[x];
        x++;
      }  
      PrintTileData (p_data);
    }
    if ((py & 2 == 2) && (py>0))
    {
      result=GetPrinterStatus();

      result=CheckForErrors();
      if(result !=0)
      {
        p_err("check errors2       ",result);
      }
    }
  }
 
  clear_screen ();
  while (1);

}
